﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Events;

namespace PreserveChangedRowBackground
{
    public partial class PreserveChangedRowBackgroundColor: Window
    {
        public PreserveChangedRowBackgroundColor()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(Window_Loaded);
            this.xamDataGrid1.InitializeRecord += new EventHandler<InitializeRecordEventArgs>(xamDataGrid1_InitializeRecord);
            this.xamDataGrid1.CellUpdated += new EventHandler<CellUpdatedEventArgs>(xamDataGrid1_CellUpdated);
        }

        void xamDataGrid1_CellUpdated(object sender, CellUpdatedEventArgs e)
        {
            if (e.Cell.Value != null && e.Cell.Value.Equals(e.Cell.Tag))
            {
                if ((bool)e.Record.Tag)
                {
                    bool flag = false;
             
                    foreach (Cell c in e.Record.Cells)
                    {
                        flag =  flag || !(c.Value != null && c.Value.Equals(c.Tag));
                    }
                    e.Record.Tag = flag;
                }
            }
            else
            {
                e.Record.Tag = true;
            }
        }

        void xamDataGrid1_InitializeRecord(object sender, InitializeRecordEventArgs e)
        {
            if (!e.ReInitialize)
            {
                DataRecord dr = e.Record as DataRecord;

                if (dr != null)
                {
                    dr.Tag = false;
                    foreach (Cell c in dr.Cells)
                        c.Tag = c.Value;
                }
            }
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            xamDataGrid1.DataSource = MyData.GetData();
        }
    }
}
